
import argparse
import sys

def hex_no_0x(val, padding):
    retstr = f'{val:0{padding}x}'
    return retstr


print('bin2inc.py - Convert binary file to includable x86 assembly file for MASM')
print(f'{sys.argv[1]}')

with open(sys.argv[1], 'rb') as infile:
    binfile = infile.read()


with open(sys.argv[2], 'w') as outfile:
    BYTES_PER_LINE = 8


    for i in range(0, len(binfile), BYTES_PER_LINE):
        outfile.write(' DB ')

        for j in range(0, BYTES_PER_LINE):
            if (i+j) > len(binfile):
                break

            outfile.write(f'0{hex_no_0x(binfile[i + j], 2)}h')
            
            if j < (BYTES_PER_LINE-1):
                outfile.write(',')
                
        
        outfile.write('\n')
